#ifndef MAGIC_SELF
#error "MAGIC_SELF not defined"
#endif

/****************************************************************************/

#include <string.h>
#include <glib-object.h>

#include "gegl/gegl-types.h"
#include "gegl/gegl-pad.h"
#include "canvas/types.h"
#include "canvas/canvas_rect.h"
#include "canvas/canvas.h"
#include "config.h"
#include "op_filter.h"
#include "op_source.h"
#include "op_sink.h"
#include "op_composer.h"

#ifdef MAGIC_SUPER_CLASS_SOURCE
  #define MAGIC_PARENT_TypeName      OpSource
  #define MAGIC_PARENT_TypeNameClass OpSourceClass
  #define MAGIC_PARENT_TYPE          TYPE_OP_SOURCE
  #define MAGIC_PARENT_CLASS         OP_SOURCE_CLASS
#endif
#ifdef MAGIC_SUPER_CLASS_FILTER
  #define MAGIC_PARENT_TypeName      OpFilter
  #define MAGIC_PARENT_TypeNameClass OpFilterClass
  #define MAGIC_PARENT_TYPE          TYPE_OP_FILTER
  #define MAGIC_PARENT_CLASS         OP_FILTER_CLASS
#endif
#ifdef MAGIC_SUPER_CLASS_COMPOSER
  #define MAGIC_PARENT_TypeName      OpComposer
  #define MAGIC_PARENT_TypeNameClass OpComposerClass
  #define MAGIC_PARENT_TYPE          TYPE_OP_COMPOSER
  #define MAGIC_PARENT_CLASS         OP_COMPOSER_CLASS
#endif
#ifdef MAGIC_SUPER_CLASS_SINK
  #define MAGIC_PARENT_TypeName      OpSink
  #define MAGIC_PARENT_TypeNameClass OpSinkClass
  #define MAGIC_PARENT_TYPE          TYPE_OP_SINK
  #define MAGIC_PARENT_CLASS         OP_SINK_CLASS
#endif

typedef struct Generated        MAGIC_TypeName;
typedef struct GeneratedClass   MAGIC_TypeNameClass;

struct Generated
{
  MAGIC_PARENT_TypeName  parent_instance;
#define magic_int(name, min, max, def)     gint     name;
#define magic_double(name, min, max, def)  gdouble  name;
#define magic_string(name, def)            gchar   *name;
#define magic_object(name)                 GObject *name;
#define magic_pointer(name)                gpointer name;

#include MAGIC_SELF
  
/****************************************************************************/

/* undefining the magic macros before all subsequent inclusions */
#undef magic_int
#undef magic_double
#undef magic_string
#undef magic_object
#undef magic_pointer

/****************************************************************************/
};

enum
{
  PROP_0,
#define magic_int(name, min, max, def)     PROP_##name,
#define magic_double(name, min, max, def)  PROP_##name,
#define magic_string(name, def)            PROP_##name,
#define magic_object(name)                 PROP_##name,
#define magic_pointer(name)                PROP_##name,

#include MAGIC_SELF

#undef magic_int
#undef magic_double
#undef magic_string
#undef magic_object
#undef magic_pointer
  PROP_LAST
};

static void get_property (GObject      *object,
                          guint         property_id,
                          GValue       *value,
                          GParamSpec   *pspec)
{
  MAGIC_TypeName *self = (MAGIC_TypeName*) object;

  switch (property_id)
  {
#define magic_int(name, min, max, def)\
    case PROP_##name: g_value_set_int (value, self->name);break;
#define magic_double(name, min, max, def)\
    case PROP_##name: g_value_set_double (value, self->name);break;
#define magic_string(name, def)\
    case PROP_##name: g_value_set_string (value, self->name);break;
#define magic_object(name)\
    case PROP_##name: g_value_set_object (value, self->name);break;
#define magic_pointer(name)\
    case PROP_##name: g_value_set_pointer (value, self->name);break;

#include MAGIC_SELF

#undef magic_int
#undef magic_double
#undef magic_string
#undef magic_object
#undef magic_pointer
    default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
      break;
  }
  self = NULL; /* silence GCC if no properties were defined */
}

static void set_property (GObject      *object,
                          guint         property_id,
                          const GValue *value,
                          GParamSpec   *pspec)
{
  MAGIC_TypeName *self = (MAGIC_TypeName*) object;

  switch (property_id)
  {
#define magic_int(name, min, max, def)\
    case PROP_##name:\
      self->name = g_value_get_int (value);\
      break;
#define magic_double(name, min, max, def)\
    case PROP_##name:\
      self->name = g_value_get_double (value);\
      break;
#define magic_string(name, def)\
    case PROP_##name:\
      if (self->name)\
        g_free (self->name);\
      self->name = g_strdup (g_value_get_string (value));\
      break;
#define magic_object(name)\
    case PROP_##name:\
      if (self->name != NULL) \
         g_object_unref (self->name);\
      self->name = g_value_get_object (value);\
      break;
#define magic_pointer(name)\
    case PROP_##name:\
      self->name = g_value_get_pointer (value);\
      break;

#include MAGIC_SELF

#undef magic_int
#undef magic_double
#undef magic_string
#undef magic_object
#undef magic_pointer

    default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
      break;
  }
  self = NULL; /* silence GCC if no properties were defined */
}

static gboolean evaluate (GeglOperation *operation,
                          const gchar   *output_prop);

static void MAGIC_type_name_init (MAGIC_TypeName *self)
{
#define magic_int(name, min, max, def)\
   self->name = def;
#define magic_double(name, min, max, def)\
   self->name = def;
#define magic_string(name, def)\
   self->name = def==NULL?NULL:g_strdup (def);
#define magic_object(name)\
   self->name = NULL;
#define magic_pointer(name)\
   self->name = NULL;


#include MAGIC_SELF

#undef magic_int
#undef magic_double
#undef magic_string
#undef magic_object
#undef magic_pointer
}

static void
MAGIC_type_name_class_init (MAGIC_TypeNameClass * klass)
{
  GObjectClass               *object_class = G_OBJECT_CLASS (klass);
  MAGIC_PARENT_TypeNameClass *parent_class = MAGIC_PARENT_CLASS (klass);

  object_class->set_property = set_property;
  object_class->get_property = get_property;
  parent_class->evaluate     = evaluate;


#define magic_int(name, min, max, def)  \
  g_object_class_install_property (object_class, PROP_##name,\
                                   g_param_spec_int (#name, #name, #name,\
                                                     min, max, def,\
                                                     G_PARAM_READWRITE |\
                                                     GEGL_PAD_INPUT));
#define magic_double(name, min, max, def)  \
  g_object_class_install_property (object_class, PROP_##name,\
                                   g_param_spec_double (#name, #name, #name,\
                                                        min, max, def,\
                                                        G_PARAM_READWRITE |\
                                                        GEGL_PAD_INPUT));
#define magic_string(name, def)  \
  g_object_class_install_property (object_class, PROP_##name,\
                                   g_param_spec_string (#name, #name, #name,\
                                                        def,\
                                                        G_PARAM_READWRITE |\
                                                        GEGL_PAD_INPUT));
#define magic_object(name)  \
  g_object_class_install_property (object_class, PROP_##name,\
                                   g_param_spec_object (#name, #name, #name,\
                                                        G_TYPE_OBJECT,\
                                                        G_PARAM_READWRITE |\
                                                        GEGL_PAD_INPUT));
#define magic_pointer(name)  \
  g_object_class_install_property (object_class, PROP_##name,\
                                   g_param_spec_pointer (#name, #name, #name,\
                                                        G_PARAM_READWRITE |\
                                                        GEGL_PAD_INPUT));
#include MAGIC_SELF

#undef magic_int
#undef magic_double
#undef magic_string
#undef magic_object
#undef magic_pointer
}

struct GeneratedClass
{
  MAGIC_PARENT_TypeNameClass parent_class;
};

G_DEFINE_TYPE (MAGIC_TypeName, MAGIC_type_name, MAGIC_PARENT_TYPE)

/****************************************************************************/
