#ifndef __OP_FILTER_H__
#define __OP_FILTER_H__

#include "../gegl/gegl-types.h"
#include "../gegl/gegl-node.h"
#include "../gegl/gegl-operation.h"
#include "canvas/types.h"
//#include "gegl-mock-image.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define TYPE_OP_FILTER               (op_filter_get_type ())
#define OP_FILTER(obj)               (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_OP_FILTER, OpFilter))
#define OP_FILTER_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST ((klass),  TYPE_OP_FILTER, OpFilterClass))
#define OP_FILTER_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS ((obj),  TYPE_OP_FILTER, OpFilterClass))

typedef struct _OpFilter  OpFilter;
struct _OpFilter
{
    GeglOperation       operation;

    /*< private >*/
    CanvasRect *input;
    CanvasRect *output;

    gboolean    in_place;
};

typedef struct _OpFilterClass OpFilterClass;
struct _OpFilterClass
{
   GeglOperationClass operation_class;
   gboolean (*evaluate) (GeglOperation *self,
                         const gchar   *output_pad);

};

GType             op_filter_get_type                  (void) G_GNUC_CONST;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
