#ifdef MAGIC_SELF
 
magic_int    (brightness,   -65536, 65536,  0)
magic_int    (contrast,     -65536*2, 65536*2,  65536)

#else

#define MAGIC_SELF                 "op_bcontrast.c"
#define MAGIC_SUPER_CLASS_POINT_FILTER
#define MAGIC_TypeName             OpBContrast
#define MAGIC_TypeNameClass        OpBContrastClass
#define MAGIC_type_name            op_bcontrast
#define MAGIC_type_name_init       op_bcontrast_init
#define MAGIC_type_name_class_init op_bcontrast_class_init
#include "magic.h"

static gboolean
evaluate (GeglOperation *op,
          guchar        *buf,
          gint           width,
          gint           height,
          gint           rowstride)
{
  OpBContrast  *self   = (OpBContrast*)(op);
  gint y;
  for (y=0; y<height; y++)
    {
      gint x;
      guchar *p = buf + rowstride * y;

      for (x=0; x<width; x++)
        {
          gint i;
          for (i=0;i<3;i++)
            {
              gint new = (p[i] - 127) * self->contrast / 65536 + 127 + self->brightness * 256 / 65536;
              if (new < 0)
                p[i] = 0;
              else if (new > 255)
                p[i] = 255;
              else
                p[i] = new;
            }
          p+=4;
        }
    }
  return TRUE;
}

#endif
