#ifdef MAGIC_SELF
 
magic_string  (path, "/tmp/romedalen.png")
magic_pointer (canvas)

#else

#define MAGIC_SELF                "op_png_load.c"
#define MAGIC_SUPER_CLASS_SOURCE
#define MAGIC_TypeName             OpPngLoad
#define MAGIC_TypeNameClass        OpPngLoadClass
#define MAGIC_type_name            op_png_load
#define MAGIC_type_name_init       op_png_load_init
#define MAGIC_type_name_class_init op_png_load_class_init
#include "magic.h"


/* Actual image processing code
 ************************************************************************/

#include "canvas/png_util.h"

static gboolean
evaluate (GeglOperation *operation,
          const gchar   *output_prop)
{
  OpSource     *op_source = OP_SOURCE(operation);
  OpPngLoad    *self      = (OpPngLoad*)(op_source);
  gint          width;
  gint          height;
  gint          result;
  gint          row_stride;
  guchar       *src;

  if(strcmp("output", output_prop))
    return FALSE;

  result = horizon_load_png (self->path, &width, &height, &row_stride, &src);
  if (result || !src)
    {
      g_warning ("%s failed to open file %s for reading.",
        G_OBJECT_TYPE_NAME (operation), self->path);
      op_source->output = NULL;
      return FALSE;
    }

  op_source->output = CANVAS_RECT (canvas_alloc ((Canvas*)(self->canvas),
     width, height));
  canvas_rect_import_buf (op_source->output, src);
  g_free (src);

  return  TRUE;
}

#endif
