#ifndef __OP_POINT_FILTER_H__
#define __OP_POINT_FILTER_H__

#include "../gegl/gegl-types.h"
#include "../gegl/gegl-node.h"
#include "../gegl/gegl-operation.h"
#include "op_filter.h"
#include "canvas/types.h"
//#include "gegl-mock-image.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define TYPE_OP_POINT_FILTER               (op_point_filter_get_type ())
#define OP_POINT_FILTER(obj)               (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_OP_POINT_FILTER, OpPointFilter))
#define OP_POINT_FILTER_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST ((klass),  TYPE_OP_POINT_FILTER, OpPointFilterClass))
#define OP_POINT_FILTER_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS ((obj),  TYPE_OP_POINT_FILTER, OpPointFilterClass))

typedef struct _OpPointFilter  OpPointFilter;
struct _OpPointFilter
{
    OpFilter   filter;
};

typedef struct _OpPointFilterClass OpPointFilterClass;
struct _OpPointFilterClass
{
   OpFilterClass  filter_class;
   gboolean (*evaluate) (GeglOperation *self,
                         guchar        *buf,
                         gint           width,
                         gint           height,
                         gint           rowstride);
};

GType             op_point_filter_get_type                  (void) G_GNUC_CONST;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
