#ifndef __OP_SINK_H__
#define __OP_SINK_H__

#include "../gegl/gegl-types.h"
#include "../gegl/gegl-node.h"
#include "../gegl/gegl-operation.h"
#include "canvas/types.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define TYPE_OP_SINK               (op_sink_get_type ())
#define OP_SINK(obj)               (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_OP_SINK, OpSink))
#define OP_SINK_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST ((klass),  TYPE_OP_SINK, OpSinkClass))
#define OP_SINK_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS ((obj),  TYPE_OP_SINK, OpSinkClass))

typedef struct _OpSink  OpSink;
struct _OpSink
{
    GeglOperation       operation;

    /*< private >*/
    CanvasRect *input;
    gboolean    process;
};

typedef struct _OpSinkClass OpSinkClass;
struct _OpSinkClass
{
   GeglOperationClass operation_class;
   gboolean (*evaluate) (GeglOperation *self,
                         const gchar   *output_pad);
};

GType             op_sink_get_type                  (void) G_GNUC_CONST;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
