#ifndef __OP_SOURCE_H__
#define __OP_SOURCE_H__

#include "../gegl/gegl-types.h"
#include "../gegl/gegl-node.h"
#include "../gegl/gegl-operation.h"
#include "canvas/types.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define TYPE_OP_SOURCE               (op_source_get_type ())
#define OP_SOURCE(obj)               (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_OP_SOURCE, OpSource))
#define OP_SOURCE_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST ((klass),  TYPE_OP_SOURCE, OpSourceClass))
#define OP_SOURCE_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS ((obj),  TYPE_OP_SOURCE, OpSourceClass))

typedef struct _OpSource  OpSource;
struct _OpSource
{
    GeglOperation  operation;

    /*< private >*/
    CanvasRect    *output;
};

typedef struct _OpSourceClass OpSourceClass;
struct _OpSourceClass
{
   GeglOperationClass operation_class;
   gboolean (*evaluate) (GeglOperation *self,
                         const gchar   *output_pad);
};

GType             op_source_get_type                  (void) G_GNUC_CONST;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
